/**
 * Author: qiuxiaoqiang@xunlei.com
 * Date  : 2015-03-10
 * Time  : 15:00
 * Describe:
 */
/*global define:false*/
"use strict";

var delTaskEntranceVersion = 10410;

var tmp = {
    advert: function (data) {
        var html = '<a href="javascript:;" class="js_advert" from="advert_pic" id="' + data.id + '" title="' + data.title + '" type="' + data.type + '" url="' + data.url_or_whichactivity + '"><img src="' + data.pic + '" width="720" height="180" alt=""></a>';
        return html;
    },
    activity: function (data) {
        var html = '<li>' +
                '<a href="javascript:;" id="' + data.id + '" url="' + data.url + '" class="js_friend_list" from="activity_list">' +
                    '<img src="img/funny_act.png" data-original="' + data.smallpic + '" class="lazy" width="210" height="117" alt="">' + data.title +
            '</a></li>';
        return html;
    },
    taskTips: function (data) {
        var html = '<span class="task_info_text js_task_link" from="showTaskNum">' +
                '待完成任务：<em class="js_unfinished_task">' + data.unfinishTask + '</em>' +
            '</span>' +
            '<span class="task_info_text">' +
                '当前积分：<em class="js_my_count"></em>' +
            '</span>' +
            '<a href="javascript:;" class="obtn obtn_shoplink js_shoplink">' +
                '积分商城' +
            '</a>';
        return html;
    },
    friendTips: function (data) {
        var html = '';
            if (data.newFriend !== '0' || data.numUpdated !== '0') {
                html += '<h2>/新增</h2><nav class="tagnav">';
                    if (data.newFriend !== '0') {
                        html += '<a href="javascript:;">' +
                            util.filterFriendNum(data.newFriend) + '朋友' +
                        '</a>';
                    }
                    if (data.numUpdated !== '0') {
                        html += '<a href="javascript:;">' +
                            util.filterFriendNum(data.numUpdated) + '视频' +
                        '</a>';
                    }
                html += '</nav>';
            }
            html += '<a href="javascript:;" class="lk_more_go js_friend_link" from="friend_list_more">' +
                '<span>' +
                    '更多' +
                '</span>' +
            '</a>';
        return html;
    },
    friendList: function (data) {
        var html = '<a href="javascript:;" url="' + data.detailUrl + '" class="recom_prev js_friend_list" from="friend_list">' +
                    '<span class="recom_pic">' +
                        '<img src="img/list_pic3.jpg" data-original="' + data.imageUrl + '" class="lazy">' +
                        '<span class="recom_pic_info">' +
                            data.source +
                        '</span>' +
                    '</span>' +
                    '<span class="recom_prev_t">' +
                        data.name +
                    '</span>' +
                    '<span class="recom_prev_sub">' +
                        data.readDate +
                    '</span>' +
                '</a>';
        return html;
    }
}
var Page = {
    initialize: function () {
        var self = this;
        window.loginCallBack = function () {
            self.getLoginStatus();
            self.task();
        }
        window.logOutCallBack = function () {
            self.getLoginStatus();
            self.task();
        }
        this.getLoginStatus();
        this.advert();
        this.activity();
        this.task();
        this.friend();
        this.events();
    },
    requestData: function (json) {
        //json.api = util.addSign(json.api);
        util.showLoadingView();
        $.ajax({
            url: json.api,
            type: 'get',
            dataType: json.dataType,
            timeout: 5000,
            success: function (data) {
                util.hideLoadingView();
                json.callback(data);
            },
            error: function (xhr, errorType, error) {
                json.errorCall();
                //util.showToast(errorType + '点击有点频繁，请重新刷新页面!');
                if (!navigator.onLine || errorType === 'timeout' ) {
                    // util.showToast('网络连接有问题，请检查网络');
                }
            }
        });
    },
    getLoginStatus: function () {
        if (!util.userId() || util.userId() === 'xxxxx' || util.userId() === '0') {
            this.isLogin = false;
        } else {
            this.isLogin = true;
        }
    },
    events: function () {
        var self = this;
        $('body').on('click', '.goLogin', function () {
            util.goToLoginPageAndCallback({
                callback: 'window.loginCallBack'
            });
        });
        $('body').on('click', '.js_advert', function () {
            var val = $(this);
            util.reportUmeng({
                actionId: 50011,
                action: 'click',
                tag: 'advert_' + val.attr('id')
            });
            util.goToActivityAdNetORActivityAdA({
                type: val.attr('type'),
                url_or_whichactivity: val.attr('url'),
                title: val.attr('title')
            });
        });
        $('body').on('click', '.js_act_link', function () {
            var val = $(this);
            util.reportUmeng({
                actionId: 50011,
                action: 'click',
                tag: 'benefitcenter_' + val.attr('from')
            });
            util.goToBenefitCenter();
        });
        $('body').on('click', '.js_task_link', function (e) {
            var node = $(e.srcElement);
            if (node.hasClass('js_go_circle_task') || node.hasClass('goLogin') || node.hasClass('js_onedollar_btn') || node.hasClass('js_get_circle_counts')) {
                return;
            }
            var val = $(this);
            util.reportUmeng({
                actionId: 50011,
                action: 'click',
                tag: 'taskactivity_' + val.attr('from')
            });
            util.goToTaskActivity();
        });
        $('body').on('click', '.js_friend_link', function () {
            var val = $(this);
            util.reportUmeng({
                actionId: 50011,
                action: 'click',
                tag: 'friend_' + val.attr('from')
            });
            util.startFriendMainActivity();
        });
        $('body').on('click', '.js_friend_list', function () {
            var val = $(this),
                umeng = {
                    actionId: 50011,
                    action: 'click',
                    tag: 'detail' + val.attr('from')
                };

            if (val.attr('from') === 'activity_list') {
                umeng.tag = umeng.tag + '_' + val.attr('id');
            }
            util.reportUmeng(umeng);
            if ($(this).attr('url').indexOf('gamejump') > -1) {
                self.reportTapGame();
            }
            if ($(this).attr('url').indexOf('1.vip.xunlei.com') > -1) {
                self.requestCounts(6);
                return;
            }
            util.openDetailPage($(this).attr('url'));
        });
        $('body').on('click', '.js_onedollar_btn', function () {
            self.requestCounts(6);
        });
        $('body').on('click', '.js_get_circle_counts', function () {
            self.requestCounts(2);
        });
        $('body').on('click', '.js_shoplink', function () {
            util.reportUmeng({
                actionId: 50011,
                action: 'click',
                tag: 'shop'
            });
            util.openDetailPage('http://m.sjzhushou.com/scoremall/index.html');
        });
        $('body').on('click', '.js_go_circle_task', function () {
            self.goCircleTask();
        });
        $('body').on('click', '.js_high_more', function (val) {
            var val = $(this);
            util.reportUmeng({
                actionId: 50011,
                action: 'click',
                tag: 'High_' + val.attr('from')
            });
            $('.tag_new').hide();
            util.goToClimaxActivity({});
        });
    },
    advert: function () {
        var self = this,
            json = {
                api: 'http://m.sjzhushou.com/xlconfig/funplayad.5.0.js?t=' + (+new Date()),
                dataType: 'json',
                pos: 1
            };
        if (util.versionCode() >= 10370) {
            json.api = 'http://m.sjzhushou.com/xlconfig/funplayad.5.1.js?t=' + (+new Date());
        }
        var callback = function (data) {
            if (data.rtn !== 0) {
                $('.funny_banner').show().append(tmp.advert(data));
            }
        }
        var errorCall = function () {}
        json.callback = callback;
        json.errorCall = errorCall;
        this.requestData(json);
    },
    entrance: function () {

    },
    activity: function () {
        var self = this,
            json = {
                api: '/cgi-bin/ActivityList?type=list&partnerId=' + util.partnerId() + '&version=' + util.versionCode() + '&t=' + (+new Date()),
                dataType: 'json',
                pos: 4
            };
        var callback = function (data) {
            if (data.data.length > 0) {
                $.each(data.data.slice(0, 2), function (i, val) {
                    $('.funny_actlist').show().find('ul').append(tmp.activity(val));
                });
                $('.funny_actlist .lazy').lazyload();
            } else {
                $('.funny_actlist').html('暂无活动，敬请期待。');
            }
        }
        var errorCall = function () {
            $('.funny_actbox a').remove();
        }
        json.callback = callback;
        json.errorCall = errorCall;
        this.requestData(json);
    },
    task: function () {
        if (window.share.getVersionCode() >= delTaskEntranceVersion) {
            return;
        }
        // 5.11不显示任务，默认隐藏了，5.11以下的就显示出来
        $('.task_info_header').show();
        $('.funny_richnav a').css('width', '23%');
        $('.task_list').show();
        var self = this,
            json = {
                api: 'http://jifenshangcheng.m.xunlei.com/cgi-bin/integra_info?userId=' + util.userId() + '&peerId=' + util.peerId() + '&versionCode=' + util.versionCode() + '&_t=' + new Date().getTime(),
                dataType: 'jsonp',
                pos: 2
            };
        var callback = function (data) {
            if (self.isLogin) {
                $('.js_task_info').show().html(tmp.taskTips(data));
                self.task_getUserCounts();
                self.updateInfo(data);
            } else {
                $('.list_task li').slice(0, 2).show();
            }
        }
        var errorCall = function () {
            $('.funny_taskbox a').remove();
        }
        json.callback = callback;
        json.errorCall = errorCall;
        this.requestData(json);
    },
    task_getUserCounts: function () {
        // 外网  http://scoremall.niu.xunlei.com:17016/
        // 内网  http://10.10.9.9:17016/
        // var self = this,
        //     json = {
        //         api: 'http://scoremall.niu.xunlei.com:17016/ScoreMall/call?a=getScore&uid=' + util.userId() + '&t=' + (+new Date()),
        //         dataType: 'jsonp',
        //         pos: 5
        //     };
        // var callback = function (data) {
        //     $('.js_my_count').text(data.data.score);
        // }
        // var errorCall = function () {}
        // json.callback = callback;
        // json.errorCall = errorCall;
        // this.requestData(json);
    },
    updateInfo: function (json) {
        var info = json.info,
            num = 0;
        if (this.isLogin) {
            // i保存在线积分
            if (info.login.counts == '18') {
                $('.js_login').remove();
            } else {
                $('.js_login').show();
                num++;
            }
            // i每日资源分享积分
            if (info.share.counts == '6') {
                $('.js_share').remove();
            } else {
                $('.js_share').show();
                num++;
            }
            // i连续签到积分
            if (info.sign.day == '7') {
                $('.js_day').remove();
            } else {
                $('.js_day').show();
                num++;
            }
            // i朋友圈
            if (info.circle.statusCode !== '1') {
                $('.js_circle').parents('li').show();
                if (info.circle.statusCode == '0') {
                    $('.js_circle').html('<a href="javascript:;" class="obtn js_get_circle_counts">领积分</a>');
                } else {
                    $('.js_circle').html('<a href="javascript:;" class="obtn js_go_circle_task">做任务</a>');
                }
                num++;
            } else {
                $('.js_circle').parents('li').remove();
            }
            // i一元夺宝
            if (info.oneDollar.statusCode == '0') {
                $('.js_onedollar').show();
                num++;
            } else {
                $('.js_onedollar').hide().appendTo($('.list_task'));
            }
            if (num == 0) {
                $('.js_onedollar').show();
            } else if (num > 2) {
                $('.list_task li').hide();
                $('.list_task li').slice(0, 2).show();
            }
        }
    },
    goCircleTask: function () {
        setTimeout(function () {
            util.userCountsOption({
                userId: util.userId(),
                optionType: 1
            });
        }, 300);
    },
    requestCounts: function (type) {
        var self = this,
            json = {
                api: 'http://jifenshangcheng.m.xunlei.com/cgi-bin/integra_b_sign?userId=' + util.userId() + '&type=' + type + '&peerId=' + util.peerId() + '&versionCode=' + util.versionCode(),
                dataType: 'jsonp',
                pos: 6
            };
        var callback = function (data) {
            if (data.code === '0') {
                self.task();
                //self.task_getUserCounts();
                util.showToast('加' + data.counts + '积分');
            } else {
                if (data.msg) {
                    // util.showToast(data.msg);
                }
            }
            if (type == 6) {
                var oneDollarHref = 'http://m.sjzhushou.com/v2/detail/detail_nx_trans.html?tab=onedollar';
                setTimeout(function () {
                    util.openDetailPageWithJson({url: oneDollarHref, module: ''});
                }, 1000);
            }
        }
        var errorCall = function () {}
        json.callback = callback;
        json.errorCall = errorCall;
        this.requestData(json);
    },
    reportTapGame: function () {
            if (!this.isLogin) {
                util.showToast('领积分需要登录哦');
                return;
            }

        var api = 'http://jifenshangcheng.m.xunlei.com/cgi-bin/integra_b_sign?userId=' + util.userId() + '&type=7&pm=android&peerId=' + util.peerId() + '&t=' + (+new Date());

        $.ajax({
            url: api,
            type: 'get',
            dataType: 'jsonp',
            timeout: 5000,
            success: function (json) {
                if (json.msg !== '') {
                    util.showToast(json.msg);
                }
            },
            error: function (xhr, errorType, error) {
                // util.showToast('网络连接有问题，请检查网络');
            }
        });
    },
    friend: function () {
        var self = this,
            userid = util.userId();

        if (!this.isLogin) {
            userid = '';
        }
        var json = {
                api: 'http://quan.m.xunlei.com/cgi-bin/friendResourceRandom?version=' + util.version() + '&productID=' + util.productId() + '&peerID=' + util.peerId() + '&imeiID=' + util.imei() + '&partnerID=' + util.partnerId() + '&versionCode=' + util.versionCode() + '&isVip=' + util.isVip() + '&screenWidth=1080&screenHeight=1920&size=1080x1920&userID=' + userid + '&type=2',
                dataType: 'jsonp',
                pos: 3
            };
        var callback = function (data) {
            $('.js_friend_header').append(tmp.friendTips(data));
            $.each(data.dataList, function (i, val) {
                $('.funny_friendlist').show().append(tmp.friendList(val));
            });
            $('.funny_friendlist .lazy').lazyload();
        }
        var errorCall = function () {}
        json.callback = callback;
        json.errorCall = errorCall;
        this.requestData(json);
    }
}

$(function () {
    Page.initialize();
})
