/**
 * Author: qiuxiaoqiang@xunlei.com
 * Date  : 2015-03-12
 * Time  : 10:00
 * Describe:
 */
/*global define:false*/
"use strict";
var Page = {
    initialize: function () {
        var self = this;
        window.loginCallBack = function () {
            self.getLoginStatus();
            self.userStatus();
            self.setVipTip();
            //location.reload();
        }
        this.getLoginStatus();
        this.userStatus();
        this.events();
        this.showDownRecord();
        this.showVipInfo();
        this.setVipTip();
    },
    requestData: function (json) {
        //json.api = util.addSign(json.api);
        util.showLoadingView();
        $.ajax({
            url: json.api,
            type: 'get',
            dataType: json.dataType,
            timeout: 5000,
            success: function (data) {
                util.hideLoadingView();
                json.callback(data);
            },
            error: function (xhr, errorType, error) {
                //util.showToast(errorType + '点击有点频繁，请重新刷新页面!');
                if (!navigator.onLine || errorType === 'timeout' ) {
                    util.showToast('网络连接有问题，请检查网络' + json.pos);
                }
            }
        });
    },
    events: function () {
        var self = this;
        $('.js_my_record').on('click', function () {
            util.reportUmeng({
                actionId: 50012,
                action: 'click',
                tag: 'my_record'
            });
            util.goToActivityMyRecord();
        });
        $('.js_vipinfo').on('click', function () {
            var val = $(this);
            util.reportUmeng({
                actionId: 50012,
                action: 'click',
                tag: 'vipinfo',
                from: val.attr('from')
            });
            util.goToActivityPaymentWay();
        });
        $('.js_shoplink').on('click', function () {
            var val = $(this);
            util.reportUmeng({
                actionId: 50012,
                action: 'click',
                tag: 'shop',
                from: val.attr('from')
            });
            util.openDetailPage('http://m.sjzhushou.com/scoremall/index.html');
        });
        $('.js_down_record').on('click', function () {
            util.reportUmeng({
                actionId: 50012,
                action: 'click',
                tag: 'down_record'
            });
            util.goToXL7DownloadListActivity();
        });
        $('.js_setting').on('click', function () {
            util.reportUmeng({
                actionId: 50012,
                action: 'click',
                tag: 'setting'
            });
            util.goToActivitySettingsIndex();
        });
        $('.js_unfinished_task_link').on('click', function () {
            util.reportUmeng({
                actionId: 50012,
                action: 'click',
                tag: 'taskactivity'
            });
            util.goToTaskActivity();
        });
        $('body').on('click', '.js_do_today_sign', function () {
            util.reportUmeng({
                actionId: 50012,
                action: 'click',
                tag: 'do_today_sign'
            });
            self.doTodaySign();
        });
        $('body').on('click', '.js_gift', function () {
            util.reportUmeng({
                actionId: 50012,
                action: 'click',
                tag: 'gift'
            });
            util.openDetailPage('http://m.sjzhushou.com/scoremall/gamegift/index.html');
        });
    },
    getLoginStatus: function () {
        if (!util.userId() || util.userId() === 'xxxxx' || util.userId() === '0') {
            this.isLogin = false;
        } else {
            this.isLogin = true;
        }
    },
    userStatus: function () {
        if (this.isLogin) {
            $('.user_name').text(util.getUserName());
            $('.headpic').removeClass('headpic_default');
            $('.portaitpath').attr('src', util.getPortaitPath());
            if (util.isVip() == '1') {
                $('.ico_vip').removeClass('disabled');
                var expireDate = util.getMemberExpireDate();
                $('.user_top_info').show().text('有效期 ' + expireDate.substr(0, 4) + '-' + expireDate.substr(4, 2) + '-' + expireDate.substr(6, 2));
            } else {
                $('.ico_vip').addClass('disabled js_vipinfo');
            }
            $('.headpic').off();
            $('.headpic').on('click', function (e) {
                var node = $(e.srcElement);
                if (node.hasClass('ico_vip')) {
                    return;
                }
                var val = $(this);
                util.reportUmeng({
                    actionId: 50012,
                    action: 'click',
                    tag: 'login',
                    from: val.attr('from')
                });
                util.goToUserInfo({
                    callback: 'window.loginCallBack'
                });
            });
            $('.user_do').show();
            this.task();
            this.task_getUserCounts();
        } else {
            $('.btn_signin, .headpic_default, .user_name').off();
            $('.user_do').hide();
            $('.headpic').addClass('headpic_default');
            $('.user_name').text('立即登录');
            $('.portaitpath').attr('src', 'img/headpic.jpg');
            $('.ico_vip').addClass('disabled');
            $('.user_top_info').text('').hide();

            $('.btn_signin, .headpic_default, .user_name').on('click', function () {
                var val = $(this);
                util.reportUmeng({
                    actionId: 50012,
                    action: 'click',
                    tag: 'unlogin',
                    from: val.attr('from')
                });
                util.goToLoginPageAndCallback({
                    callback: 'window.loginCallBack'
                });
            });
        }
    },
    showDownRecord: function () {
        if (util.partnerId() === '0x10810144') {
            $('.js_down_record').show();
        }
        /*var self = this,
            json = {
                api: 'http://m.sjzhushou.com/xlconfig/down_record.js',
                dataType: 'json',
                pos: 7
            };
        var callback = function (data) {
            if (data.show === '1') {
                $('.js_down_record').show();
            }
        }
        json.callback = callback;
        this.requestData(json);*/
    },
    showVipInfo: function () {
        if (util.versionCode() > 10360) {
            $('.js_vipinfo').parent().show();
        }
    },
    getSignStatus: function (data) {
        var signStatus = data.todaySign,
            signDay = data.info.sign.day;
        this.signDay = signDay;
        if (signStatus == 0) {
            $('.btn_signin').addClass('js_do_today_sign');
        } else {
            $('.btn_signin').html('已签到 <em class="sign_day">' + signDay + '</em>/7天').addClass('btn_signin_done disabled');
        }
    },
    doTodaySign: function () {
        var that = this,
            url = 'http://jifenshangcheng.m.xunlei.com/cgi-bin/integra_b_sign?userId=' + util.userId() + '&type=0&peerId=' + util.peerId() + '&_t=' + new Date().getTime();
        // TODO: replace API and change to post
        util.showLoadingView();
        //url = util.addSign(url);
        $.ajax({
            url: url,
            type: 'get',
            dataType: 'jsonp',
            timeout: 5000,
            success: function (json) {
                util.hideLoadingView();
                var signDay = parseInt(that.signDay) + 1,
                    counts = parseInt(json.counts);
                if (json.code === '0') {
                    $('.btn_signin').addClass('btn_signin_done disabled').removeClass('js_do_today_sign').html('已签到 <em class="sign_day">' + signDay + '</em>/7天');
                    if (signDay === 7) {
                        counts = counts + 20;
                        util.showToast('加' + counts + '积分 /达成7日成就，明天继续');
                    } else {
                        util.showToast('加' + counts + '积分 /7天连续签到有惊喜');
                    }
                    that.task_getUserCounts();
                } else {
                    util.showToast(json.msg);
                }
            },
            error: function (xhr, errorType, error) {
                util.hideLoadingView();
                if (!navigator.onLine || errorType == 'timeout' ) {
                    util.goToLoginPageAndCallback({
                        callback: 'window.loginCallBack'
                    });
                    util.showToast('网络连接有问题，请检查网络9');
                } else {
                    util.showToast('网络连接有问题，请检查网络10');
                }
            }
        });
    },
    task: function () {
        var self = this,
            json = {
                api: 'http://jifenshangcheng.m.xunlei.com/cgi-bin/integra_info?userId=' + util.userId() + '&peerId=' + util.peerId() + '&versionCode=' + util.versionCode() + '&_t=' + new Date().getTime(),
                dataType: 'jsonp',
                pos: 2
            };
        var callback = function (data) {
            self.getSignStatus(data);
            if (!data.unfinishTask) {
                $('.js_unfinished_task_link').find('em').html(':)');
                $('.js_unfinished_task_link').find('span').text('所有任务已完成')
            } else {
                $('.js_unfinished_task_link').find('em').text(data.unfinishTask);
            }
        }
        json.callback = callback;
        this.requestData(json);
    },
    task_getUserCounts: function () {
        // 外网  http://scoremall.niu.xunlei.com:17016/
        // 内网  http://10.10.9.9:17016/
        var self = this,
            json = {
                api: 'http://scoremall.niu.xunlei.com:17016/ScoreMall/call?a=getScore&uid=' + util.userId() + '&t=' + (+new Date()),
                dataType: 'jsonp',
                pos: 5
            };
        var callback = function (data) {
            $('.js_my_count').text(data.data.score);
        }
        json.callback = callback;
        this.requestData(json);
    },
    setVipTip: function() {
        if(this.isLogin) {
            // 已经登录，判断是否会员
            if (util.isVip() == '1') {
                // 是会员，判断会员到期日 20150423
                var expireDate = util.getMemberExpireDate();
                var now = new Date();
                var y = now.getFullYear(),
                    m = (now.getMonth() + 1) > 9 ? (now.getMonth() + 1) : ('0' + (now.getMonth() + 1)),
                    d = now.getDate() > 9 ? now.getDate() : '0' + now.getDate();
                var today = y + m + d;
                var dateDiff = parseInt(expireDate) - parseInt(today);
                if(dateDiff>3) {
                    $('#vipTip').html(expireDate.substr(0, 4) + '-' + expireDate.substr(4, 2) + '-' + expireDate.substr(6, 2) + '到期');
                } else {
                    $('#vipTip').css('color', '#ff7a15');
                    $('#vipTip').html('还剩' + dateDiff + '天到期');
                }
            } else {
                // 不是会员
                $('#vipTip').html('开通会员飞一般的感觉');
            }
        } else {
            // 未登录
            $('#vipTip').html('');
        }
    }
}

/**
 * 切换模式显示
 * @param  {int} status     切换状态。0白天，1夜间
 * @return {[type]}         [description]
 */
window.switchNightModeCallback = function(status) {
    if(status==0) {
        // 白天
        $('.user_top_model').removeClass('night').addClass('day');
        $('.user_top_model').html('<a href="#" class="btn_switch"><span class="uico"></span>日间</a>');
    } else {
        // 夜间
        $('.user_top_model').removeClass('day').addClass('night');
        $('.user_top_model').html('<a href="#" class="btn_switch"><span class="uico"></span>夜间</a>');
    }
}

$(function () {
    Page.initialize();
    $('.user_top_model').bind('tap', function() {
        util.switchNightMode();
    });
    switchNightModeCallback(util.isNightMode());
    $('.user_top_model').show();
})
