/**
 * Author: qiuxiaoqiang@xunlei.com
 * Date  : 2015-03-10
 * Time  : 15:00
 * Describe:
 */
/*global define:false*/
"use strict";
window.$ = $;
//lazyload 扩展 依赖于 $ scrollTop scrollLeft
(function($, window, document, undefined) {
    var $window = $(window);

    $.fn.lazyload = function(options) {
        var elements = this;
        var $container;
        var settings = {
            threshold       : 0,
            failure_limit   : 0,
            event           : "scroll",
            effect          : "show",
            container       : window,
            data_attribute  : "original",
            skip_invisible  : true,
            appear          : null,
            load            : null
        };

        function update(state) {
            var counter = 0;

            elements.each(function() {
                var $this = $(this);
                if (settings.skip_invisible && !$this.css("display") == 'none' && $this.css("visibility") == 'hidden') {
                    return;
                }
                if ($.abovethetop(this, settings) ||
                    $.leftofbegin(this, settings)) {
                    /* Nothing. */
                } else if (!$.belowthefold(this, settings) &&
                    !$.rightoffold(this, settings)) {
                    $this.trigger("appear");
                    /* if we found an image we'll load, reset the counter */
                    counter = 0;
                } else {
                    if (++counter > settings.failure_limit) {
                        return false;
                    }
                }
            });

        }

        if(options) {
            /* Maintain BC for a couple of versions. */
            if (undefined !== options.failurelimit) {
                options.failure_limit = options.failurelimit;
                delete options.failurelimit;
            }
            if (undefined !== options.effectspeed) {
                options.effect_speed = options.effectspeed;
                delete options.effectspeed;
            }

            $.extend(settings, options);
        }

        /* Cache container as jQuery as object. */
        $container = (settings.container === undefined ||
            settings.container === window) ? $window : $(settings.container);

        /* Fire one scroll event per scroll. Not one scroll event per image. */
        if (0 === settings.event.indexOf("scroll")) {
            $container.bind(settings.event, function(event) {
                return update();
            });
        }

        this.each(function() {
            var self = this;
            var $self = $(self);

            self.loaded = false;

            /* When appear is triggered load original image. */
            $self.one("appear", function() {
                if (!this.loaded) {
                    if (settings.appear) {
                        var elements_left = elements.length;
                        settings.appear.call(self, elements_left, settings);
                    }
                    $("<img />")
                        .bind("load", function() {
                            $self
                                .hide().removeClass('lazy')
                                .attr("src", $self.data(settings.data_attribute))
                                [settings.effect](settings.effect_speed);
                            self.loaded = true;

                            /* Remove image from array so it is not looped next time. */
                            var temp = $.grep(elements, function(element) {
                                return !element.loaded;
                            });
                            elements = $(temp);

                            if (settings.load) {
                                var elements_left = elements.length;
                                settings.load.call(self, elements_left, settings);
                            }
                        })
                        .bind('error', function () {
                            $self.parents('.pic_bor, .pic_aico').addClass('img_err');
                        })
                        .attr("src", $self.data(settings.data_attribute));
                }
            });

            /* When wanted event is triggered load original image */
            /* by triggering appear.                              */
            if (0 !== settings.event.indexOf("scroll")) {
                $self.bind(settings.event, function(event) {
                    if (!self.loaded) {
                        $self.trigger("appear");
                    }
                });
            }
        });

        /* Check if something appears when window is resized. */
        $window.bind("resize", function(event) {
            update();
        });

        /* With IOS5 force loading images when navigating with back button. */
        /* Non optimal workaround. */
        if ((/iphone|ipod|ipad.*os 5/gi).test(navigator.appVersion)) {
            $window.bind("pageshow", function(event) {
                if (event.originalEvent.persisted) {
                    elements.each(function() {
                        $(this).trigger("appear");
                    });
                }
            });
        }

        /* Force initial check if images should appear. */
        /*$(window).load(function() {
         update();
         });*/
        /*window.onload = function () {
            update();
        };*/
        setTimeout(function () {
            update();
        }, 300);
        this.update = update;

        return this;
    };

    /* Convenience methods in jQuery namespace.           */
    /* Use as  $.belowthefold(element, {threshold : 100, container : window}) */

    $.belowthefold = function(element, settings) {
        var fold;

        if (settings.container === undefined || settings.container === window) {
            fold = $window.height() + $window.scrollTop();
        } else {
            fold = $(settings.container).offset().top + $(settings.container).height();
        }

        return fold <= $(element).offset().top - settings.threshold;
    };

    $.rightoffold = function(element, settings) {
        var fold;

        if (settings.container === undefined || settings.container === window) {
            fold = $window.width() + $window.scrollLeft();
        } else {
            fold = $(settings.container).offset().left + $(settings.container).width();
        }

        return fold <= $(element).offset().left - settings.threshold;
    };

    $.abovethetop = function(element, settings) {
        var fold;

        if (settings.container === undefined || settings.container === window) {
            fold = $window.scrollTop();
        } else {
            fold = $(settings.container).offset().top;
        }

        return fold >= $(element).offset().top + settings.threshold  + $(element).height();
    };

    $.leftofbegin = function(element, settings) {
        var fold;

        if (settings.container === undefined || settings.container === window) {
            fold = $window.scrollLeft();
        } else {
            fold = $(settings.container).offset().left;
        }

        return fold >= $(element).offset().left + settings.threshold + $(element).width();
    };

    $.inviewport = function(element, settings) {
        return !$.rightoffold(element, settings) && !$.leftofbegin(element, settings) &&
            !$.belowthefold(element, settings) && !$.abovethetop(element, settings);
    };
})($, window, document);

var util = {
    filterFriendNum: function (num) {
        if (parseInt(num) > 99) {
            return '99+';
        } else {
            return num;
        }
    },
    getUriValue: function (key, href) {
        var reg = new RegExp("(^|\\?|&)" + key + "=([^&#]*)(\\s|#|&|$)", "i");
        if (reg.test((href || location.href))) {
            return decodeURIComponent(RegExp.$2.replace(/\+/g, " "));
        } else {
            return "";
        }
    },
    userId: function () {
        var userID = 'xxxxx';
        try {
            userID = window.share.getUserId();
        } catch (e) {
            userID = util.getUriValue('userid');
        }
        return userID;
    },
    getUserId: function() {
        try {
            return window.share.getUserId();
        } catch(e) {
            console.log('getUserId error');
        }
    },
    getUserName: function () {
        var nickName;
        try {
            nickName = window.share.getUserName();
        } catch (e) {
            nickName = util.getUriValue('userName') || '';
        }
        return nickName;
    },
    getPortaitPath: function () {
        var path;
        try {
            path = window.share.getPortaitPath();
        } catch (e) {
            path = '';
        }
        return path;
    },
    getMemberExpireDate: function () {
        var date;
        try {
            date = window.share.getMemberExpireDate();
        } catch (e) {
            date = '';
        }
        return date;
    },
    version: function () {
    	var version;
        try {
	        version = window.share.getClientVersion();
	    } catch (e) {
	        version = '2.10';
	    }
        return version;
    },
    saveKeyValueString : function (json) {
        try {
            window.share.saveKeyValueString(JSON.stringify(json));
        } catch (e) {
            console.log(json);
        }
    },
    getValueFromKeyString : function (key) {
        try {
            return window.share.getValueFromKeyString(key);
        } catch (e) {
            console.log(key);
        }
    },
    switchNightMode: function() {
        try {
            window.share.switchNightMode();
        } catch (e) {
            console.log('tap switchNightMode');
        }
    },
    isNightMode: function() {
        try {
            return window.share.isNightMode();
        } catch (e) {
            console.log('isNightMode error');
        }
    },
    inStallTalbumApk: function(packageName) {
        try {
            window.share.inStallTalbumApk(packageName);
        } catch(e) {
            console.log('inStallTalbumApk error');
        }
    },
    inFirstKAccel: function () {
        var firstKAccel;
        try {
            firstKAccel = window.share.inFirstKAccel();
        } catch (e) {
            firstKAccel = 1;
        }
        return firstKAccel;
    },
    versionCode: function () {
    	var versionCode;
        try {
	        versionCode = parseInt(window.share.getVersionCode());
	    } catch (e) {
	        versionCode = util.getUriValue('versionCode') || 10160;
	    }
        return versionCode;
    },
    partnerId: function () {
        var partnerID = 'XXXXXXXXXXXX004V';
        try {
	        partnerID = window.share.getPartnerId();
	    } catch (e) {
	        partnerID = util.getUriValue('partnerid') || 'xxxxx';
	    }
        return partnerID;
    },
    productId: function () {
        var productID = 'XXXXXXXXXXXX004V';
        try {
	        productID = window.share.getProductId();
	    } catch (e) {
	        productID = util.getUriValue('productid') || 'xxxxx';
	    }
        return productID;
    },
    peerId: function () {
        var peerID = 'XXXXXXXXXXXX004V';
        try {
            peerID = window.share.getPeerId();
        } catch (e) {
            peerID = util.getUriValue('peer_id');
        }
        return peerID;
    },
    isVip: function () {
        var vip;
        try {
            vip = window.share.isVip();
        } catch (e) {
        	vip = util.getUriValue('isVip') || 0;
        }
        return vip;
    },
    imei: function () {
    	var imei;
        try {
	        imei = window.share.getImei();
	    } catch (e) {
	        imei = util.getUriValue('imei') || 'xxxxx';
	    }
	    return imei;
    },
    goToLoginPage: function () {
        try {
            window.share.goToLoginPage();
        } catch (e) {
            console.log(e);
        }
    },
    goToUserInfo: function (json) {
        try {
            window.share.goToUserInfo(JSON.stringify(json));
        } catch (e) {
            console.log(json);
        }
    },
    goToLoginPageAndCallback: function (json) {
        try {
            window.share.goToLoginPageAndCallback(JSON.stringify(json));
        } catch (e) {
            console.log(json);
        }
    },
    goToActivityMyRecord: function () {
        try {
            window.share.goToActivityMyRecord();
        } catch (e) {
            console.log('');
        }
    },
    goToActivityAdNetORActivityAdA: function (json) {
        try {
            window.share.goToActivityAdNetORActivityAdA(JSON.stringify(json));
        } catch (e) {
            console.log(json);
        }
    },
    goToActivityPaymentWay: function () {
        try {
            window.share.goToActivityPaymentWay();
        } catch (e) {
            console.log('');
        }
    },
    goToActivityPaymentWayWithParam: function(json) {
        try {
            window.share.goToActivityPaymentWay(JSON.stringify(json));
        } catch (e) {
            console.log('');
        }
    },
    goToActivitySettingsIndex: function () {
        try {
            window.share.goToActivitySettingsIndex();
        } catch (e) {
            console.log('');
        }
    },
    showToast: function (text) {
        try {
            window.share.showToast(text);
        } catch (e) {
            alert(text);
        }
    },
    gotoKuaiNiao: function () {
        try {
            window.share.gotoKuaiNiao();
        } catch (e) {
            console.log(e.message);
        }
    },
    goToClimaxActivity: function (json) {
        try {
            window.share.goToClimaxActivity(JSON.stringify(json));
        } catch (e) {
            console.log(e.message);
        }
    },
    openBrowserPage: function (url) {
        try {
            window.share.openBrowserPage(url);
        } catch (e) {
            window.location.href = url;
        }
    },
    openDetailPage: function (url) {
        try {
            window.share.openDetailPage(url);
        } catch (e) {
            window.location.href = url;
        }
    },
    openDetailPageWithJson: function (json) {
        try {
            window.share.openDetailPageWithJson(JSON.stringify(json));
        } catch (e) {
            window.location.href = json.url;
        }
    },
    startFriendMainActivity: function () {
        try {
            window.share.startFriendMainActivity();
        } catch (e) {
            console.log();
        }
    },
    hideLoadingView: function () {
        try {
            window.share.hideLoadingView();
        } catch (e) {

        }
    },
    showLoadingView: function () {
        try {
            window.share.showLoadingView();
        } catch (e) {

        }
    },
    goToBenefitCenter: function () {
        try {
            window.share.goToBenefitCenter();
        } catch (e) {
            console.log('');
        }
    },
    goToTaskActivity: function () {
        try {
            window.share.goToTaskActivity();
        } catch (e) {
            console.log('');
        }
    },
    goToGameGiftTab: function () {
        try {
            window.share.goToGameGiftTab();
        } catch (e) {
            console.log('');
        }
    },
    goToXL7DownloadListActivity: function () {
        try {
            window.share.goToXL7DownloadListActivity();
        } catch (e) {
            console.log('');
        }
    },
    userCountsOption: function (json) {
        try {
            window.share.userCountsOption(JSON.stringify(json));
        } catch (e) {
            console.log(json);
        }
    },
    addSign: function (url) {
        var versionCode,
            version;
        try {
            version = window.share.getClientVersion();
        } catch (e) {
            version = '2.10';
        }
        try {
            versionCode = parseInt(window.share.getVersionCode());
        } catch (e) {
            var versionTmp = version.match(/(^\d{1}\.\d*)?\.*/)[1];
            if (versionTmp) {
                if (versionTmp === '2.3') {
                    versionCode = 10126;
                } else if (versionTmp === '2.2') {
                    versionCode = 10125;
                } else {
                    versionCode = 10124;
                }
            }
            versionCode = util.getUriValue('versionCode') || 10160;
        }
        try {
            if (versionCode > 10190) {
                return window.share.addSign(url);
            }
        } catch (e) {
            return url;
        }
    },
    reportUmeng: function (json) {
        var tmp = {
            actionId: json.actionId,
            data: []
        }, list = tmp.data;

        for (var name in json) {
            if (name != 'actionId') {
                list.push({
                    key: name,
                    value: json[name]
                });
            }
        }

        try {
            window.share.reportUmeng(JSON.stringify(tmp));
        } catch (e) {
            console.log(tmp);
        }
    },
    getDownloadFinishedTasks: function (maxCount) {
        var json;
        try {
            json = window.share.getDownloadFinishedTasks(maxCount);
        } catch (e) {
            json = {
                taskInfos: [/*{
                    "taskId": 12,   //任务id
                    "fileName": "abc.avi",  //任务文件名称
                    "filePath": "/sdcard/xunlei"    //文件路径
                },
                {
                    "taskId": 13,   //任务id
                    "fileName": "ddd.avi",  //任务文件名称
                    "filePath": "/sdcard/xunlei"    //文件路径
                }*/]
            }
            console.log(maxCount);
        }
        return json;
    },
    vodFromLocal: function (filePath) {
        try {
            window.share.vodFromLocal(filePath);
        } catch (e) {
            console.log(filePath);
        }
    },
    getPlayRecords: function (maxCount) {
        var json;
        try {
            json = window.share.getPlayRecords(maxCount);
        } catch (e) {
            json = {
                "vodInfos": [
                    {
                        "type": "yunbo",
                        "title": "我是title",
                        "gcid": "sdasdaewe212",
                        "cid": "dsduiu12i212",
                        "fileSize": 121221244,
                        "url": "http://www.baidu.com"
                    },
                    {
                        "type": "online",
                        "ref_id": "1221",
                        "ref_url": "http://www.baidu.com",
                        "tag": "tag",
                        "title": "我是title",
                        "playedTime": "08:30"
                    },
                    {
                        "type": "local",
                        "url": "http://www.baidu.com",
                        "title": "我是title",
                        "playedTime": "08:30"
                    }
                ]
            }
        }
        return json;
    },
    goToRemoteDownload: function () {
        try {
            window.share.goToRemoteDownload();
        } catch (e) {
            console.log(e.message);
        }
    },
    goToSelectSavePath: function () {
        try {
            window.share.goToSelectSavePath();
        } catch (e) {
            console.log(e.message);
        }
    },
    goToDownloadSetting: function () {
        try {
            window.share.goToDownloadSetting();
        } catch (e) {
            console.log(e.message);
        }
    },
    vodYunbo: function (json) {
        try {
            window.share.vodYunbo(JSON.stringify(json));
        } catch (e) {
            console.log(json);
        }
    },
    goToDownloadList: function () {
        try {
            window.share.goToDownloadList();
        } catch (e) {
            console.log(e.message);
        }
    },
    goToCloudPlayRecord: function () {
        try {
            window.share.goToCloudPlayRecord();
        } catch (e) {
            console.log(e.message);
        }
    },
    multiPlay: function (json) {
        if (json.epList[0].tag === 'soku_sohu' && !json.epList[0].sliced
            && json.epList[0].dataList && json.epList[0].dataList.length > 0) {
            json.epList[0].sliced = true;
        }
        try {
            window.share.multiPlay(JSON.stringify(json));
        } catch (e) {
            console.log(json);
        }
    },
    goToLoginPageParameter: function(json) {
        try {
            window.share.goToLoginPageParameter(JSON.stringify(json));
        } catch(e) {
            console.log('goToLoginPageParameter error');
        }
    },
}
